/*
	In the Make_GB_Core  and menu_Edit function,
	I have used getch instead of the get_key_press.
	The use of latter function will allow construction
	of core if there are less than 24 atoms in the core.
	After that the screen will scroll.
*/


#include			<stdio.h>
#include			<stdlib.h>
#include			<alloc.h>
#include			<float.h>
#include			<math.h>
#include			<string.h>
#include			<time.h>
#include			<graphics.h>
#include			"my_menu.h"
#include			"mygr_def.h"
#include			"mygr_ve.h"
#include			"adeshdef.h"
#include			"adeshve.h"
#include			"desh_gen.h"
#include			"iapdef.h"
#include			"deshgrph.h"
#include			"deshfile.h"
#include			"desh_atm.h"
#include			"gen_eng.h"


void set_up_graphics()
 {
	int i,j,k;
	int gdriver = DETECT, gmode, errorcode;

	printf("\a");
/* initialize graphics mode */
initgraph(&gdriver, &gmode, "");

/* read result of initialization */
errorcode = graphresult();

 if (errorcode != grOk)  /* an error
														occurred */
	{
		printf("\nGraphics Error ");
		printf("\n Hit any key to continue ....");
		Graphics_Error=DESH_YES;
		i=get_key_press();
	}

/* restore system to text mode */
		Graphics_Error=DESH_NO;
		settextstyle(DEFAULT_FONT, HORIZ_DIR, 2);
	 restorecrtmode();
 }

int View_CC()
 {
	int i, j, k, l, m, n;
	float x1, x2, y1, y2;
	float a, b, c;
	int maxx, maxy, ht;
	int v_left, v_top, v_width, v_height;
	char temp[20];
	int x_index[3], y_index[3];
	int plot_color;
	int Plot_Atom, Colors_Set;
	int	Color_List[16];

	VN_New_Screen();
	if((Total_Atoms<=0) || (cell_planes <= 0))
	{
	 printf("No cell to view\n");
	 printf("No of atoms = %d   No of cell planes = %d\n",
				Total_Atoms, cell_planes);
	 printf("\n Hit any key to continue ....");
	 i=get_key_press();
	 return(VN_MENU_CONTINUE);
	}

	if(Graphics_Error == DESH_YES)
	{
	 printf("\nGraphics Error. Can not implement VIEW\n");
	 printf("\n Hit any key to continue ....");
	 i=get_key_press();
	 return(VN_MENU_CONTINUE);
	}

/* return to graphics mode */
	setgraphmode(getgraphmode());
	maxx=getmaxx();	maxy=getmaxy();
	Color_List[0] = 0;
	Colors_Set = 1;

/* Re-order the atoms */

	switch (Selected_Plot_Type)
		{
			case Y_vs_X:
				{
					atom_ptr=atom_ptr_temp;
					break;
				}
			case Z_vs_X:
				{
					atom_ptr=atom_ptr_temp;
					for(i=0; i<Total_Atoms; i++)
						{
							a = atom_ptr->YC;
							atom_ptr->YC = atom_ptr->ZC;
							atom_ptr->ZC = a;
							atom_ptr++;
						}
					atom_ptr=atom_ptr_temp;
					qsort((void *)atom_ptr, Total_Atoms, 14, sort_function);
					atom_ptr=atom_ptr_temp;
					break;
				}
			case Y_vs_Z:
				{
					atom_ptr=atom_ptr_temp;
					for(i=0; i<Total_Atoms; i++)
						{
							a = atom_ptr->ZC;
							atom_ptr->ZC = atom_ptr->XC;
							atom_ptr->XC = a;
							atom_ptr++;
						}
					atom_ptr=atom_ptr_temp;
					qsort((void *)atom_ptr, Total_Atoms, 14, sort_function);
					atom_ptr=atom_ptr_temp;
					break;
				}
		}

	i=(8*maxy)/10;
	j=(maxx-i)/2;
	k=maxy/10;
	v_left=j;	v_top=k;	v_width=i;	v_height=i;
	switch (Selected_Plot_Type)
	{
	 case Y_vs_X:
		{
		if((subset[PLOT].TYPE == CUBIC) || (subset[PLOT].TYPE == ENTIRE_CELL))
		 {
			a = subset[PLOT].XMAX - subset[PLOT].XMIN;
			b = subset[PLOT].YMAX - subset[PLOT].YMIN;
			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].XMIN;
					x2 = subset[PLOT].XMAX;
					y1 = (subset[PLOT].YMIN+subset[PLOT].YMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].YMIN;
					y2 = subset[PLOT].YMAX;
					x1 = (subset[PLOT].XMIN+subset[PLOT].XMAX)/2 - a/2;
					x2 = x1 + a;
				}
		 }

		if(subset[PLOT].TYPE == CYLINDRICAL)
		 {
	a = 2.*subset[PLOT].C_RMAX;
	b = a;
	x1 = -subset[PLOT].C_RMAX;
	x2 = subset[PLOT].C_RMAX;
	y1 = -subset[PLOT].C_RMAX;
	y2 = subset[PLOT].C_RMAX;
		 }
		if(subset[PLOT].TYPE == SPHERICAL)
		 {
	a = 2.*subset[PLOT].SP_RMAX;
	b = a;
	x1 = -subset[PLOT].SP_RMAX;
	x2 = subset[PLOT].SP_RMAX;
	y1 = -subset[PLOT].SP_RMAX;
	y2 = subset[PLOT].SP_RMAX;
		 }
		if(subset[PLOT].TYPE == SLICE)
		 {
	a = subset[PLOT].S_XMAX - subset[PLOT].S_XMIN;
	b = subset[PLOT].S_YMAX - subset[PLOT].S_YMIN;

			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].S_XMIN;
					x2 = subset[PLOT].S_XMAX;
					y1 = (subset[PLOT].S_YMIN+subset[PLOT].S_YMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].S_YMIN;
					y2 = subset[PLOT].S_YMAX;
					x1 = (subset[PLOT].S_XMIN+subset[PLOT].S_XMAX)/2 - a/2;
					x2 = x1 + a;
				}

		 }


		x_index[0] = current_axes[0][0];
		x_index[1] = current_axes[1][0];
		x_index[2] = current_axes[2][0];
		y_index[0] = current_axes[0][1];
		y_index[1] = current_axes[1][1];
		y_index[2] = current_axes[2][1];

		break;
		}
	 case Z_vs_X:
		{
		if((subset[PLOT].TYPE == CUBIC) || (subset[PLOT].TYPE == ENTIRE_CELL))
		 {
			a = subset[PLOT].XMAX - subset[PLOT].XMIN;
			b = subset[PLOT].ZMAX - subset[PLOT].ZMIN;

			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].XMIN;
					x2 = subset[PLOT].XMAX;
					y1 = (subset[PLOT].ZMIN+subset[PLOT].ZMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].ZMIN;
					y2 = subset[PLOT].ZMAX;
					x1 = (subset[PLOT].XMIN+subset[PLOT].XMAX)/2 - a/2;
					x2 = x1 + a;
				}
		 }

		if(subset[PLOT].TYPE == CYLINDRICAL)
		 {
	a = 2.*subset[PLOT].C_RMAX;
	b = subset[PLOT].ZMAX - subset[PLOT].ZMIN;
	x1 = -subset[PLOT].C_RMAX;
	x2 = subset[PLOT].C_RMAX;
	y1 = subset[PLOT].ZMIN;
	y2 = subset[PLOT].ZMAX;
		 }
		if(subset[PLOT].TYPE == SPHERICAL)
		 {
	a = 2.*subset[PLOT].SP_RMAX;
	b = a;
	x1 = -subset[PLOT].SP_RMAX;
	x2 = subset[PLOT].SP_RMAX;
	y1 = -subset[PLOT].SP_RMAX;
	y2 = subset[PLOT].SP_RMAX;
		 }

		if(subset[PLOT].TYPE == SLICE)
		 {
	a = subset[PLOT].S_XMAX - subset[PLOT].S_XMIN;
	b = subset[PLOT].S_YMAX - subset[PLOT].S_YMIN;

			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].S_XMIN;
					x2 = subset[PLOT].S_XMAX;
					y1 = (subset[PLOT].S_YMIN+subset[PLOT].S_YMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].S_YMIN;
					y2 = subset[PLOT].S_YMAX;
					x1 = (subset[PLOT].S_XMIN+subset[PLOT].S_XMAX)/2 - a/2;
					x2 = x1 + a;
				}

		 }


		x_index[0] = current_axes[0][0];
		x_index[1] = current_axes[1][0];
		x_index[2] = current_axes[2][0];
		y_index[0] = current_axes[0][2];
		y_index[1] = current_axes[1][2];
		y_index[2] = current_axes[2][2];

		break;
		}
	 case Y_vs_Z:
		{
		if((subset[PLOT].TYPE == CUBIC) || (subset[PLOT].TYPE == ENTIRE_CELL))
		 {
			a = subset[PLOT].ZMAX - subset[PLOT].ZMIN;
			b = subset[PLOT].YMAX - subset[PLOT].YMIN;

			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].ZMIN;
					x2 = subset[PLOT].ZMAX;
					y1 = (subset[PLOT].YMIN+subset[PLOT].YMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].YMIN;
					y2 = subset[PLOT].YMAX;
					x1 = (subset[PLOT].ZMIN+subset[PLOT].ZMAX)/2 - a/2;
					x2 = x1 + a;
				}
		 }

		if(subset[PLOT].TYPE == CYLINDRICAL)
		 {
	a = subset[PLOT].ZMAX - subset[PLOT].ZMIN;
	b = 2.*subset[PLOT].C_RMAX;
	x1 = subset[PLOT].ZMIN;
	x2 = subset[PLOT].ZMAX;
	y1 = -subset[PLOT].C_RMAX;
	y2 = subset[PLOT].C_RMAX;
		 }
		if(subset[PLOT].TYPE == SPHERICAL)
		 {
	a = 2.*subset[PLOT].SP_RMAX;
	b = a;
	x1 = -subset[PLOT].SP_RMAX;
	x2 = subset[PLOT].SP_RMAX;
	y1 = -subset[PLOT].SP_RMAX;
	y2 = subset[PLOT].SP_RMAX;
		 }

		if(subset[PLOT].TYPE == SLICE)
		 {
			a = subset[PLOT].S_XMAX - subset[PLOT].S_XMIN;
			b = subset[PLOT].S_YMAX - subset[PLOT].S_YMIN;

			if(a>=b)
				{
					b=a;
					x1 = subset[PLOT].S_XMIN;
					x2 = subset[PLOT].S_XMAX;
					y1 = (subset[PLOT].S_YMIN+subset[PLOT].S_YMAX)/2 - a/2;
					y2 = y1+a;
				}
			else
				{
					a = b;
					y1 = subset[PLOT].S_YMIN;
					y2 = subset[PLOT].S_YMAX;
					x1 = (subset[PLOT].S_XMIN+subset[PLOT].S_XMAX)/2 - a/2;
					x2 = x1 + a;
				}

		 }


		x_index[0] = current_axes[0][2];
		x_index[1] = current_axes[1][2];
		x_index[2] = current_axes[2][2];
		y_index[0] = current_axes[0][1];
			y_index[1] = current_axes[1][1];
		y_index[2] = current_axes[2][1];

		break;
		 }
	}

	setcolor(15);
//  rectangle(v_left, v_top, v_left+v_width, v_top+v_height);

/* set the fill style */
	setfillstyle(SOLID_FILL,0);

/* draw the 3-d bar */
	bar3d(0, 0, maxx-1, maxy-1, 0, 0);

	rectangle(v_left, v_top, v_left+v_width, v_top+v_height);

	ht = textheight("W");
					i=textwidth("CASA : ADESH !");
					i = maxx/2 + ((maxx/2) - i)/2;
					outtextxy(i, 2*ht, "CASA : ADESH");
					i=textwidth("914 226-1925");
					i = maxx/2 + ((maxx/2) - i)/2;
					outtextxy(i, 4*ht, "914 226-1925");

	sprintf(temp,"%5.1f",x2);
	i=textwidth(temp);
	outtextxy(v_left+v_width-i/2, v_top+v_height+2*ht,temp);

	sprintf(temp,"%5.1f",y2);
	i=textwidth(temp);
	outtextxy(v_left-i-10, v_top-ht,temp);

	sprintf(temp,"%5.1f",x1);
	i=textwidth(temp);
	outtextxy(v_left-i/2, v_top+v_height+2*ht,temp);

	sprintf(temp,"%5.1f",y1);
	i=textwidth(temp);
	outtextxy(v_left-i-10, v_top+v_height-ht,temp);

	j=v_left + v_width/2 - 15;
	k=v_top + v_height + 2*ht;
	outtextxy(j,k,"[");
	j=j+textwidth("[");
	i=0;
	while(i<3)
	{
		if(x_index[i] < 0)
		{
			sprintf(temp,"%1.1d",-x_index[i]);
			outtextxy(j,k,temp);
			outtextxy(j,k-ht,"_");
			j=j+textwidth(temp);
		}
		else
		{
			sprintf(temp,"%1.1d",x_index[i]);
			outtextxy(j,k,temp);
			j=j+textwidth(temp);
		}

	 if(i<2)
		 {
			outtextxy(j,k,",");
			j=j+textwidth(",");
		}
	 else
		 {
		outtextxy(j,k,"]");
		 }

		i++;
	 }



	j=v_left - 75;
	k=v_top+v_height/2;
	outtextxy(j,k,"[");
	j=j+textwidth("[");
	i=0;
	while(i<3)
	 {
		if(y_index[i] < 0)
		 {
		sprintf(temp,"%1.1d",-y_index[i]);
		outtextxy(j,k,temp);
			outtextxy(j,k-ht,"-");
		j=j+textwidth(temp);
		 }
		else
		 {
			sprintf(temp,"%1.1d",y_index[i]);
		outtextxy(j,k,temp);
			j=j+textwidth(temp);
		}

	 if(i<2)
		 {
		outtextxy(j,k,",");
		j=j+textwidth(",");
		}
		else
		 {
		outtextxy(j,k,"]");
		}

	 i++;
	}


	setviewport(v_left, v_top, v_left+v_width, v_top+v_height, 1);

	atom_ptr=atom_ptr_temp;
	setcolor(15);
	i=0;
	while(i<Total_Atoms)
	{
/*
		if(atom_ptr->TYPE == VACANCY)
		 {
			i++;
			atom_ptr++;
			continue;
		 }
*/
		Plot_Atom = DESH_OUT_SIDE;
		switch (Selected_Plot_Type)
			{
				case Y_vs_X:
					{
						Plot_Atom=check_within_subset(atom_ptr->XC, atom_ptr->YC,
													 atom_ptr->ZC, PLOT);
						break;
					}

				case Z_vs_X:
					{
						Plot_Atom=check_within_subset(atom_ptr->XC, atom_ptr->ZC,
													 atom_ptr->YC, PLOT);
						break;
					}

				case Y_vs_Z:
					{
						Plot_Atom=check_within_subset(atom_ptr->ZC, atom_ptr->YC,
													 atom_ptr->XC, PLOT);
						break;
					}
			}


/*		if(check_within_subset(atom_ptr->XC,
					 atom_ptr->YC,
					 atom_ptr->ZC,
					 PLOT) == DESH_IN_SIDE)
*/
		if(Plot_Atom == DESH_IN_SIDE)
		 {
			if(Plot_Color_Code == COLOR_PLANES)
				{
					j=atom_ptr->PLANE;
					if(j < 0)
						j=1;
					k=Periodic_Planes[2];
					if(k < 0)
						k=2;
					if(k>14)
						k=14;
					l=j/k;
					j = j - l*k;
					j=j+1;
					if(j > 14)
						j=j-14;
					plot_color=j;
					if(atom_ptr->TYPE == VACANCY)
						plot_color=0;
				}
			else
				{
					k=0;
					while(k<Colors_Set)
						{
							if(Color_List[k] == (int)atom_ptr->TYPE)
								break;
							k++;
						}
					if(k != Colors_Set)
						plot_color=k;
					else
						{
							if(Colors_Set > 16)
								plot_color = 15;
							else
								{
									plot_color = Colors_Set;
									Color_List[Colors_Set] = (int)atom_ptr->TYPE;
									Colors_Set++;
								}
						}
				}


			setfillstyle(SOLID_FILL,plot_color);
			k = (int)((float)v_width *
			(atom_ptr->XC - x1) / a);
			l = (int)((float)v_height *
			(atom_ptr->YC - y1) / b);
			l = v_height - l;
			c = Element[atom_ptr->TYPE].Radius;
			m = (int)((float)v_height*c/a);
			n = (int)((float)v_height*c/b);
			fillellipse(k,l,m,n);
		 }
		i++;
		atom_ptr++;
	}

	if(subset[PLOT].TYPE == CYLINDRICAL)
	{
	 ellipse((v_width/2), (v_height/2), 0, 360, v_width/2, v_height/2);
	 i=(v_height*subset[PLOT].C_RMIN)/(2.*subset[PLOT].C_RMAX);
	 if(i > 0)
		ellipse((v_width/2), (v_height/2), 0, 360, i, i);
	}

	setviewport(0,0,maxx,maxy,1);
	rectangle(v_left, v_top, v_left+v_width, v_top+v_height);

	i=get_key_press();

	switch (Selected_Plot_Type)
		{
			case Y_vs_X:
				{
					atom_ptr=atom_ptr_temp;
					break;
				}
			case Z_vs_X:
				{
					atom_ptr=atom_ptr_temp;
					for(i=0; i<Total_Atoms; i++)
						{
							a = atom_ptr->YC;
							atom_ptr->YC = atom_ptr->ZC;
							atom_ptr->ZC = a;
							atom_ptr++;
						}
					atom_ptr=atom_ptr_temp;
					qsort((void *)atom_ptr, Total_Atoms, 14, sort_function);
					atom_ptr=atom_ptr_temp;
					break;
				}
			case Y_vs_Z:
				{
					atom_ptr=atom_ptr_temp;
					for(i=0; i<Total_Atoms; i++)
						{
							a = atom_ptr->ZC;
							atom_ptr->ZC = atom_ptr->XC;
							atom_ptr->XC = a;
							atom_ptr++;
						}
					atom_ptr=atom_ptr_temp;
					qsort((void *)atom_ptr, Total_Atoms, 14, sort_function);
					atom_ptr=atom_ptr_temp;
					break;
				}
		}

	restorecrtmode();
	return(VN_MENU_CONTINUE);

 }


int	MC_Energy_Plot()
	{
		int i;
		int	maxx, maxy;
		float	E_Min, E_Max;
		double	E_Sum_1, E_Sum_2;
		double w;
		char temp[50];


		if(Graphics_Error == DESH_YES)
			{
			 printf("\nGraphics Error. Can not implement VIEW\n");
			 printf("\n Hit any key to continue ....");
			 i=get_key_press();
			 return(-1);
			}

//		p_menu_screen=VideoSave(1,1,25,80);
/*
	int sangraph(void);
	int _openwindow(int i, int scope_switch,
						 int grcolor, int txcolor, int bgcolor, int sc_color, int grid_color,
						 int a, int b, int c, int d);
	int _clearwindow(int i);
	void _closewindow(int j);
	int _switchwindow(int i);
	int plinit(int i, int j, double a, double b, double c, double d);
	int plaxis(int i, char xlabel[], char ylabel[], int grid);
	int pliyt(int i, int *ptry, float tinc, int ist, int isp,
	 int istep, int ipen, int isym, int size, int icolor,
	 float t_offset, float y_offset);
	int	goto_col_row(int i, int j);
	int	blank_line(int col, int row, int line_size);
*/

/* return to graphics mode */
//			setgraphmode(getgraphmode());
			sangraph();
			maxx = getmaxx()-1;		maxy = getmaxy()-1;
			_openwindow(0, 0, 14, 12, 0, 0, 0,
									0, 0, maxx, maxy);
			plinit(0, 1, (double)MC_Plot_Xmin, (double)MC_Plot_Ymin,
									 (double)MC_Plot_Xmax, (double)MC_Plot_Ymax);
			plaxis(0, "Iteration #", "Energy (eV)", 0);
			i=(int)MC_Plot_Xmin;
			_moveto_w((double)(i), (double)MC_Energies[i-1]);
			i++;
			while(i <= (int)MC_Plot_Xmax)
				{
					_lineto_w((double)(i), (double)MC_Energies[i-1]);
					i++;
				}
//			pliyt(0, MC_Energies, 1., (int)MC_Plot_Xmin, (int)MC_Plot_Xmax,
//								1, 1, 0, 0, 14, 0., 0.);
			i=(int)MC_Plot_Xmin;
			E_Sum_1=0.;
			E_Sum_2=0.;
			E_Min = MC_Energies[i-1];
			E_Max = MC_Energies[i-1];
			while(i <= MC_Plot_Xmax)
				{
					E_Sum_1 = E_Sum_1 + MC_Energies[i-1];
					E_Sum_2 = E_Sum_2 + MC_Energies[i-1] * MC_Energies[i-1];
					if(E_Min > MC_Energies[i-1])
						E_Min = MC_Energies[i-1];
					if(E_Max < MC_Energies[i-1])
						E_Max = MC_Energies[i-1];
					i++;
				}
			if(MC_Plot_Xmax - MC_Plot_Xmin <= 1)
				{
					E_Sum_2=0.;
					E_Sum_1=0.;
				}
			else
				{
					E_Sum_1 = E_Sum_1/(double)(MC_Plot_Xmax - MC_Plot_Xmin+1);
					E_Sum_2 = E_Sum_2/(double)(MC_Plot_Xmax - MC_Plot_Xmin+1);
					E_Sum_2 = E_Sum_2 - E_Sum_1 * E_Sum_1;
					w = sqrt(E_Sum_2);
					E_Sum_2=w;
				}
			sprintf(temp, "Minimum : %8.2f", E_Min);
			goto_col_row(20,2);
			outtext(temp);
			sprintf(temp, "Maximum : %8.2f", E_Max);
			goto_col_row(40,2);
			outtext(temp);
			sprintf(temp, "Mean    : %8.2f", (float)E_Sum_1);
			goto_col_row(20,3);
			outtext(temp);
			sprintf(temp, "SD      : %8.3f", (float)E_Sum_2);
			goto_col_row(40,3);
			outtext(temp);
			i=getch();
			restorecrtmode();

			return(0);

	}



int	Make_GB_Core(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	 float ymin, ymax, xmin, xmax;
	 float x_center, y_center, scale_factor;
	 int i, j, maxx, maxy, min_pixle, border_size, rad_pixle;
	 int x_left, x_right, y_top, y_bottom;
	 int Action_Valid, GB_Atoms;
	 char temp[40];
	 int	ht;

	 struct atom_specs *atom_ptr_bottom;

	 if((Graphics_Error == DESH_YES) || (Total_Atoms <= 0))
		{
		 printf("\n No GB created or read in? or\n\n");
		 printf("\n No graphic adapter? \n\n");
		 printf(" Hit ant key to continue ....");
			i=get_key_press();
		 return(VN_MENU_CONTINUE);
		}


	 File_Modification = DESH_YES;

	 ymin = atom_ptr->YC;
	 ymax = atom_ptr->YC;
	 atom_ptr = atom_ptr_temp;
	 i=0;
	 while(i < Total_Atoms)
		{
		if(ymin > atom_ptr->YC) ymin = atom_ptr->YC;
		 if(ymax < atom_ptr->YC) ymax = atom_ptr->YC;
		atom_ptr++;
		i++;
		}
	 xmax = (ymax-ymin)/2.;
	 xmin = -xmax;

	 setgraphmode(getgraphmode());
	 maxx=getmaxx();	maxy=getmaxy();
	 if(maxx < maxy)min_pixle = maxx;
	 if(maxx > maxy)min_pixle = maxy;
	 border_size = 0.05*min_pixle;

	 scale_factor = (min_pixle - 2*border_size) / (xmax - xmin);

	 atom_ptr = atom_ptr_temp;
	 i=0;
	 while(i < Total_Atoms)
		{
		if((atom_ptr->XC < xmin) || (atom_ptr->XC > xmax)  ||
			( (atom_ptr->XC >= -GB_Core_Width/2.) &&
				(atom_ptr->XC <= GB_Core_Width/2.))    )
		 {
			i++;
			atom_ptr++;
			continue;
		 }
		x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
		y_center = min_pixle-border_size-
				(int)(scale_factor*(atom_ptr->YC-ymin));
		rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
		setfillstyle(SOLID_FILL, atom_ptr->PLANE);
		fillellipse(x_center, y_center, rad_pixle, rad_pixle);
		i++;
		atom_ptr++;
		}

//		i=get_key_press();
		i=getch();

	 atom_ptr = atom_ptr_temp;
	 setfillstyle(SOLID_FILL, RED);
	 i=0;
	 while(i < Total_Atoms)
		{
		if((atom_ptr->XC >= -GB_Core_Width/2.) &&
			(atom_ptr->XC <= GB_Core_Width/2.))
		 {
			x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
			y_center = min_pixle-border_size-
				(int)(scale_factor*(atom_ptr->YC-ymin));
			rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
			fillellipse(x_center, y_center, rad_pixle, rad_pixle);
		 }
		atom_ptr++;
		i++;
	 }

	x_left = border_size + (int)(scale_factor * (-GB_Core_Width/2. - xmin));
	y_top =  border_size;
	x_right = border_size + (int)(scale_factor * (GB_Core_Width/2. - xmin));
	y_bottom = min_pixle - border_size;
	setcolor(WHITE);
	rectangle(x_left, y_top, x_right, y_bottom);

	x_right = border_size + (int)(scale_factor * (-xmin));
	rectangle(x_left, y_top, x_right, y_bottom);

	atom_ptr_bottom = atom_ptr_temp;
	for(i = 0; i < Total_Atoms; atom_ptr_bottom++, i++);
	GB_Atoms = Total_Atoms;
	atom_ptr = atom_ptr_temp;

	i=0;
	while(i < Total_Atoms)
	 {
		if((atom_ptr->XC >= -GB_Core_Width/2.) &&
			(atom_ptr->XC <= GB_Core_Width/2.))
			{
				setfillstyle(SOLID_FILL, YELLOW);
				x_center = border_size+(int)(scale_factor*(atom_ptr->XC-xmin));
				y_center = min_pixle-border_size-
							(int)(scale_factor*(atom_ptr->YC-ymin));
				rad_pixle=(int)(scale_factor*Element[atom_ptr->TYPE].Radius);
				fillellipse(x_center, y_center, rad_pixle, rad_pixle);
				ht = textheight("W");
					sprintf(temp, "D : Delete");
					outtextxy(maxx-20*ht, 1*ht, temp);
					sprintf(temp, "R : Reflect");
					outtextxy(maxx-20*ht, 3*ht, temp);
					sprintf(temp, "M : Move to Center");
					outtextxy(maxx-20*ht, 5*ht, temp);
					sprintf(temp, "K : Keep");
					outtextxy(maxx-20*ht, 7*ht, temp);

				Action_Valid = DESH_NO;
				while(Action_Valid == DESH_NO)
				 {


//					j = get_key_press();
					j = getch();
					switch (j)
					{
						case DESH_D:
						case DESH_d:
						 {
							setfillstyle(SOLID_FILL, BLACK);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							atom_ptr->TYPE = -1;
							Action_Valid = DESH_YES;
							break;
						 }

						case DESH_K:
						case DESH_k:
						 {
							setfillstyle(SOLID_FILL, atom_ptr->PLANE);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							Action_Valid = DESH_YES;
							break;
						 }

						case DESH_M:
						case DESH_m:
						 {
							setfillstyle(SOLID_FILL, BLACK);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
								atom_ptr->XC = 0.;
							x_center = min_pixle/2;
							setfillstyle(SOLID_FILL, atom_ptr->PLANE);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							Action_Valid = DESH_YES;
							break;
						 }

						case DESH_R:
						case DESH_r:
						 {
							setfillstyle(SOLID_FILL, atom_ptr->PLANE);
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							atom_ptr_bottom->XC = -atom_ptr->XC;
							atom_ptr_bottom->YC = atom_ptr->YC;
							atom_ptr_bottom->ZC = atom_ptr->ZC;
							atom_ptr_bottom->TYPE = atom_ptr->TYPE;
							atom_ptr_bottom->PLANE = -atom_ptr->PLANE;
							x_center = border_size +
									(int)(scale_factor*(atom_ptr_bottom->XC-xmin));
							fillellipse(x_center, y_center, rad_pixle, rad_pixle);
							atom_ptr_bottom++;
							GB_Atoms++;
							Action_Valid = DESH_YES;
							break;
						 }


						default:
						 {
							Action_Valid = DESH_NO;
								break;
						 }

					}
				 }
			}
			if(GB_Atoms >= MAX_ATOMS)
			{
			 moveto(min_pixle + 2*border_size, min_pixle/2);
			 outtext("Exceeded atom limits");
			 j=get_key_press();
			 break;
			}
			atom_ptr++;
			i++;
	 }

	 i=0;
	 atom_ptr = atom_ptr_temp;
	 atom_ptr_bottom = atom_ptr_temp;
	 Total_Atoms=0;
	 while(i < GB_Atoms)
		{
		if(atom_ptr_bottom->TYPE >= 0)
		 {
			if(atom_ptr != atom_ptr_bottom)
			{
			 atom_ptr->XC = atom_ptr_bottom->XC;
			 atom_ptr->YC = atom_ptr_bottom->YC;
			 atom_ptr->ZC = atom_ptr_bottom->ZC;
			 atom_ptr->TYPE = atom_ptr_bottom->TYPE;
			 atom_ptr->PLANE = atom_ptr_bottom->PLANE;
			}
			atom_ptr++;
			Total_Atoms++;
		}
		atom_ptr_bottom++;
		i++;
	 }

//	 i=get_key_press();
	 i=getch();
	 restorecrtmode();
	 clrscr();
	 atom_ptr=atom_ptr_temp;

	 printf("\nSorting the atoms .....");
		planes_and_periodicity();
		printf("\n Hit any key to continue ....");
//	 i=get_key_press();
	 i=getch();

	 return(VN_MENU_EXIT);
	}


int menu_Edit(VN_Menu *VN_Menu_Name, int VN_Menu_Entry)
	{
	int i, j, k, l, m, n, o, Current_Edit_Atom, User_Input, All_Done, i_Neb;
	float x1, x2, y1, y2, z1, z2;
	float a, b, c, d, g, g1, g2, h, rcut_i, rcut_j;
	float e, f, x, y, z, r, neb_x, neb_y, neb_z;
	double r2;
	float edit_delta;
	int maxx, maxy, ht, Neighbours, k1, j1;
	int v_left[4], v_top[4], v_width[4], v_height[4];
	char temp[40];
	int x_index[3], y_index[3];
	int plot_color;

	struct atom_specs *Edit_Atom_ptr, *Atom_Neb_ptr;

	if((Total_Atoms<=0) || (cell_planes <= 0))
	{
	 printf("No cell to view\n");
	 printf("No of atoms = %d   No of cell planes = %d\n",
				Total_Atoms, cell_planes);
	 printf("\n Hit any key to continue ....");
	 i=getch();
//    return(PULLDOWN_CONTINUE);
	 return(VN_MENU_EXIT);
	}

	if(Graphics_Error == DESH_YES)
	{
	 printf("\nGraphics Error. Can not implement VIEW\n");
	 printf("\n Hit any key to continue ....");
	 i=getch();
//    return(PULLDOWN_CONTINUE);
	 return(VN_MENU_EXIT);
	}

	File_Modification = DESH_YES;

	edit_delta = 0.1;
	i=0;
	Edit_Atom_ptr=atom_ptr_temp;
	while(i < Total_Atoms)
	{
		if(check_within_subset(Edit_Atom_ptr->XC,
			 Edit_Atom_ptr->YC,
			 Edit_Atom_ptr->ZC,
			 EDIT) == DESH_IN_SIDE)
				break;
		i++;
		Edit_Atom_ptr++;
	}
	if(i >= Total_Atoms)
	{
		printf("\n The subset does not contain any atom");
		printf("\n Hit any key to continue ...");
		i=getch();
		return(VN_MENU_EXIT);
	}

	Current_Edit_Atom = i;
	rcut_i = Element[Edit_Atom_ptr->TYPE].IAP_PAR[0];
	x = Edit_Atom_ptr->XC;
	y = Edit_Atom_ptr->YC;
	z = Edit_Atom_ptr->ZC;
	g1 = (float)sqrt((double)rcut_i);


/* return to graphics mode */
	setgraphmode(getgraphmode());
	maxx=getmaxx();	maxy=getmaxy();

	j = (int)((float)maxy * .45);
	k = ((maxy/2) - j) / 2;
	i = ((maxx/2) - j) / 2;
	v_left[0] = i;	v_left[1] = i + maxx/2;	v_left[2] = i;	v_left[3] = v_left[1];
	v_top[0] = maxy/2 + k;	v_top[1] = v_top[0];	v_top[2] = k; v_top[3] = v_top[2];
	for(i=0; i< 3; v_width[i] = j, v_height[i] = j, i++);

		if((subset[EDIT].TYPE == CUBIC) || (subset[EDIT].TYPE == ENTIRE_CELL))
		 {
			a = subset[EDIT].XMAX - subset[EDIT].XMIN;
			b = subset[EDIT].YMAX - subset[EDIT].YMIN;
			c = subset[EDIT].ZMAX - subset[EDIT].ZMIN;
			x1 = subset[EDIT].XMIN;	x2 = subset[EDIT].XMAX;
			y1 = subset[EDIT].YMIN;	y2 = subset[EDIT].YMAX;
			z1 = subset[EDIT].ZMIN;	z2 = subset[EDIT].ZMAX;
			set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == CYLINDRICAL)
		 {
	a = 2.*subset[EDIT].C_RMAX;
	b = a;
	c = subset[EDIT].ZMAX - subset[EDIT].ZMIN;
	x1 = -subset[EDIT].C_RMAX;
	x2 = subset[EDIT].C_RMAX;
	y1 = -subset[EDIT].C_RMAX;
	y2 = subset[EDIT].C_RMAX;
	z1 = subset[EDIT].ZMIN;	z2 = subset[EDIT].ZMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == SPHERICAL)
		 {
	a = 2.*subset[EDIT].SP_RMAX;
	b = a;
	c = a;
	x1 = -subset[EDIT].SP_RMAX;
	x2 = subset[EDIT].SP_RMAX;
	y1 = -subset[EDIT].SP_RMAX;
	y2 = subset[EDIT].SP_RMAX;
	z1 = -subset[EDIT].SP_RMAX;
	z2 = subset[EDIT].SP_RMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

		if(subset[EDIT].TYPE == SLICE)
		 {
	a = subset[EDIT].S_XMAX - subset[EDIT].S_XMIN;
	b = subset[EDIT].S_YMAX - subset[EDIT].S_YMIN;
	c = subset[EDIT].S_ZMAX - subset[EDIT].S_ZMIN;
	x1 = subset[EDIT].S_XMIN;	x2 = subset[EDIT].S_XMAX;
	y1 = subset[EDIT].S_YMIN;	y2 = subset[EDIT].S_YMAX;
	z1 = subset[EDIT].S_ZMIN;	z2 = subset[EDIT].S_ZMAX;
	set_plot_scales(&a, &b, &c, &x1, &x2, &y1, &y2, &z1, &z2);
		 }

  setcolor(14);

	ht = textheight("W");


	User_Input= 'N';
	while(1)
  {
	  switch (User_Input)
		{
			case DESH_N:
			case	DESH_n:
				{
				  clearviewport();
					i=textwidth("CASA : ADESH !");
				  i = maxx/2 + ((maxx/2) - i)/2;
				  outtextxy(i, 2*ht, "CASA : ADESH !");
				  i=textwidth("914 226-1925, USA");
					i = maxx/2 + ((maxx/2) - i)/2;
					outtextxy(i, 4*ht, "914 226-1925, USA");

				  for(i=0; i<3; i++)
					{
						rectangle(v_left[i], v_top[i],
									v_left[i]+v_width[i], v_top[i]+v_height[i]);
					}
					plot_color=3;
				  i=cell_planes;
				  while(i>=1)
					{
					 setfillstyle(1,plot_color);
					 atom_ptr=atom_ptr_temp;
					 j=0;
					 while(j<Total_Atoms)
						{
						if(atom_ptr->PLANE == i)
						 {
							if(check_within_subset(atom_ptr->XC,
								 atom_ptr->YC,
								 atom_ptr->ZC,
								 EDIT) == DESH_IN_SIDE)
							 {
								if(atom_ptr->TYPE == VACANCY)
									setfillstyle(1,VACANCY);
								r = Element[atom_ptr->TYPE].Radius;
								m = (int)((float)v_height[0]*r/a);
								n = (int)((float)v_height[0]*r/b);

								k = (int)((float)v_width[0] *
									(atom_ptr->XC - x1) / a) + v_left[0];
								l = (int)((float)v_height[0] *
									(atom_ptr->YC - y1) / b);
								l = v_height[0] - l + v_top[0];
								fillellipse(k,l,m,n);

								k = (int)((float)v_width[1] *
									(atom_ptr->ZC - z1) / c) + v_left[1];
								l = (int)((float)v_height[1] *
									(atom_ptr->YC - y1) / b);
								l = v_height[1] - l + v_top[1];
								fillellipse(k,l,m,n);

								k = (int)((float)v_width[2] *
									(atom_ptr->XC - x1) / a) + v_left[2];
								l = (int)((float)v_height[2] *
								  (atom_ptr->ZC - z1) / c);
								l = v_height[2] - l + v_top[2];
								fillellipse(k,l,m,n);
								if(atom_ptr->TYPE == VACANCY)
									setfillstyle(1,plot_color);
							 }
						 }
						atom_ptr++;
						j++;
						}

					 i--;
					 plot_color++;
					 if(plot_color > Periodic_Planes[2]+3)
						plot_color=3;
					 if(plot_color > 13)
						plot_color=3;
					}

				 Atom_Neb_ptr=atom_ptr_temp;
				 j=0;
				 Neighbours=0;
				 plot_color=1;
				 setfillstyle(1,plot_color);
				 while(j < Total_Atoms)
					{
						if(j != Current_Edit_Atom)
							{
								d = Atom_Neb_ptr->XC;
								e = Atom_Neb_ptr->YC;
								f = Atom_Neb_ptr->ZC;
								rcut_j = Element[(int)Atom_Neb_ptr->TYPE].IAP_PAR[0];
								g2=(float)sqrt((double)rcut_j);
								h=(g1+g2)/2.;
								g=h*h;
								if( Is_Neb(x, y, z, d, e, f, h, g) == 0)
									{
										if(Atom_Neb_ptr->TYPE == VACANCY)
											setfillstyle(1,VACANCY);

										r = Element[Atom_Neb_ptr->TYPE].Radius;
										m = (int)((float)v_height[0]*r/a);
										n = (int)((float)v_height[0]*r/b);

										for(i_Neb=0; i_Neb < Periodic_Nebs_Found; i_Neb++)
											{

										k = (int)((float)v_width[0] *
												(x - Periodic_Neb_Positions[i_Neb][0] - x1) / a) + v_left[0];
										l = (int)((float)v_height[0] *
												(y - Periodic_Neb_Positions[i_Neb][1] - y1) / b);
										l = v_height[0] - l + v_top[0];
										fillellipse(k,l,m,n);

										k = (int)((float)v_width[1] *
												(z - Periodic_Neb_Positions[i_Neb][2] - z1) / c) + v_left[1];
										l = (int)((float)v_height[1] *
												(y - Periodic_Neb_Positions[i_Neb][1] - y1) / b);
										l = v_height[1] - l + v_top[1];
										fillellipse(k,l,m,n);

										k = (int)((float)v_width[2] *
												(x - Periodic_Neb_Positions[i_Neb][0] - x1) / a) + v_left[2];
										l = (int)((float)v_height[2] *
												(z - Periodic_Neb_Positions[i_Neb][2] - z1) / c);
										l = v_height[2] - l + v_top[2];
										fillellipse(k,l,m,n);

										if(Atom_Neb_ptr->TYPE == VACANCY)
											setfillstyle(1,plot_color);

										Neighbours++;
											}
									}
							}
						Atom_Neb_ptr++;
						j++;
					}

					sprintf(temp," Neighbours : %d",Neighbours);
					outtextxy(v_left[3], v_top[3]+9*ht, temp);
					sprintf(temp," Type : %s", Chem_Sym[(int)Edit_Atom_ptr->TYPE]);
					outtextxy(v_left[3], v_top[3]+7*ht, temp);

					sprintf(temp, "         T : Change atom type");
					outtextxy(v_left[3], v_top[3]+12*ht, temp);
					sprintf(temp, "      %c %c: Move along X", LEFT_ARROW, RIGHT_ARROW);
					outtextxy(v_left[3], v_top[3]+14*ht, temp);
					sprintf(temp, "      %c %c: Move along Y", UP_ARROW, DOWN_ARROW);
					outtextxy(v_left[3], v_top[3]+16*ht, temp);
					sprintf(temp, " ALT F & B : Front & Back along Z");
					outtextxy(v_left[3], v_top[3]+18*ht, temp);
					sprintf(temp, "     Enter : Next atom");
					outtextxy(v_left[3], v_top[3]+20*ht, temp);
					sprintf(temp, "       Esc : Exit");
					outtextxy(v_left[3], v_top[3]+22*ht, temp);




				 plot_color=2;
				 setfillstyle(1,plot_color);

				 r = Element[Edit_Atom_ptr->TYPE].Radius;
				 m = (int)((float)v_height[0]*r/a);
				 n = (int)((float)v_height[0]*r/b);

				 k = (int)((float)v_width[0] *
							(x - x1) / a) + v_left[0];
				 l = (int)((float)v_height[0] *
							(y - y1) / b);
				 l = v_height[0] - l + v_top[0];
				 fillellipse(k,l,m,n);

				 k = (int)((float)v_width[1] *
							(z - z1) / c) + v_left[1];
				 l = (int)((float)v_height[0] *
							(y - y1) / b);
				 l = v_height[1] - l + v_top[1];
				 fillellipse(k,l,m,n);

				 k = (int)((float)v_width[2] *
							(x - x1) / a) + v_left[2];
				 l = (int)((float)v_height[2] *
							(z - z1) / b);
				 l = v_height[2] - l + v_top[2];
				 fillellipse(k,l,m,n);


				 All_Done=DESH_NO;
				 User_Input=getch();
				 break;
				}


				case 0:
					{
						k1=getch();
									switch(k1)
										{
											case DESH_R_ARROW:
												{
													Edit_Atom_ptr->XC = x + edit_delta;
													x = Edit_Atom_ptr->XC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_L_ARROW:
												{
													Edit_Atom_ptr->XC = x - edit_delta;
													x = Edit_Atom_ptr->XC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_U_ARROW:
												{
													Edit_Atom_ptr->YC = y + edit_delta;
													y = Edit_Atom_ptr->YC;
													User_Input = 'N';
													All_Done=DESH_NO;
													break;
												}

											case DESH_D_ARROW:
												{
													Edit_Atom_ptr->YC = y - edit_delta;
													y = Edit_Atom_ptr->YC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}


											case DESH_ALT_F:
												{
													Edit_Atom_ptr->ZC = z + edit_delta;
													z = Edit_Atom_ptr->ZC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}

											case DESH_ALT_B:
												{
													Edit_Atom_ptr->ZC = z - edit_delta;
													z = Edit_Atom_ptr->ZC;
													All_Done=DESH_NO;
													User_Input = 'N';
													break;
												}



											default:
												{
													User_Input = DESH_YES;
													All_Done = DESH_NO;
												}
										}
//								}
							break;
					}


			case DESH_ENTER:
				{
					while(Current_Edit_Atom < Total_Atoms)
						{
							Edit_Atom_ptr++;
							Current_Edit_Atom++;
							if(check_within_subset(Edit_Atom_ptr->XC,
									 Edit_Atom_ptr->YC,
									 Edit_Atom_ptr->ZC,
									 EDIT) == DESH_IN_SIDE)
								break;
						}
					if(Current_Edit_Atom >= Total_Atoms)
						{
							All_Done=DESH_YES;
							break;
						}

					x = Edit_Atom_ptr->XC;
					y = Edit_Atom_ptr->YC;
					z = Edit_Atom_ptr->ZC;
					rcut_i = Element[Edit_Atom_ptr->TYPE].IAP_PAR[0];
					g1 = (float)sqrt((double)rcut_i);
					All_Done=DESH_NO;
					User_Input='N';
					break;
				}

			case DESH_ESCAPE:
				{
					All_Done=DESH_YES;
					break;
				}

			case DESH_T:
			case DESH_t:
				{
					setviewport(0,0,maxx,maxy,1);
					restorecrtmode();
					Selected_Atom_Type = Edit_Atom_ptr->TYPE;
					menu_Element_Selection();
					Edit_Atom_ptr->TYPE = Selected_Atom_Type;
					All_Done=DESH_NO;
					User_Input='N';
					setgraphmode(getgraphmode());
					break;
				}

			default:
						{
							All_Done=DESH_NO;
							printf("\a");
							User_Input=getch();
						}

		}
		if(All_Done == DESH_YES)
			break;
	}
	setviewport(0,0,maxx,maxy,1);
	restorecrtmode();
	return(VN_MENU_CONTINUE);
	}

void	set_plot_scales(float *a, float *b, float *c,
							 float *x1, float *x2, float *y1, float *y2,
							 float *z1, float *z2)
		{
			int j;

			if((*a >= *b) && (*a >= *c))
				j=0;
			if((*b >= *a) && (*b >= *c))
				j=1;
			if((*c >= *a) && (*c >= *b))
				j=2;

			switch (j)
				{
					case 0:
						{
					*b = *a;
					*x1 = subset[EDIT].XMIN;
					*x2 = subset[EDIT].XMAX;
					*y1 = (subset[EDIT].YMIN + subset[EDIT].YMAX - (*x2 - *x1))/2.;
					*y2 = *y1 + (*x2 - *x1);
					*c = *a;
					*z1 = (subset[EDIT].ZMIN + subset[EDIT].ZMAX - (*x2 - *x1))/2.;
					*z2 = *z1 + (*x2 - *x1);
					break;
						}
					case 1:
						{
					*a = *b;
					*y1 = subset[EDIT].YMIN;
					*y2 = subset[EDIT].YMAX;
					*x1 = (subset[EDIT].XMIN + subset[EDIT].XMAX - (*y2 - *y1))/2.;
					*x2 = *x1 + (*y2 - *y1);
					*c = *b;
					*z1 = (subset[EDIT].ZMIN + subset[EDIT].ZMAX - (*y2 - *y1))/2.;
					*z2 = *z1 + (*y2 - *y1);
					break;
						}
					case 2:
						{
					*a = *c;
					*z1 = subset[EDIT].ZMIN;
					*z2 = subset[EDIT].ZMAX;
					*x1 = (subset[EDIT].XMIN + subset[EDIT].XMAX - (*z2 - *z1))/2.;
					*x2 = *x1 + (*x2 - *x1);
					*b = *c;
					*y1 = (subset[EDIT].YMIN + subset[EDIT].YMAX - (*z2 - *z1))/2.;
					*y2 = *y1 + (*z2 - *z1);
					break;
						}
				}
		}
